unit RegFileId;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls;

type
  TfrmTypeId = class(TForm)
    lvFileTypes: TListView;
    btnCancel: TButton;
    btnOk: TButton;
    Button1: TButton;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure btnOkClick(Sender: TObject);
    procedure lvFileTypesDblClick(Sender: TObject);
  private
    FId : String; 
    procedure LoadList;
    procedure SetId(const Value: String);
  public
    property Id : String read FId write SetId;
  end;

var
  frmTypeId: TfrmTypeId;

implementation

{$R *.DFM}

procedure TfrmTypeId.FormCreate(Sender: TObject);
begin
  LoadList;
end;

procedure TfrmTypeId.LoadList;
var
  i : Integer;
  size : DWORD;
  Tmp : String;
  S   : String;
  LI : TListItem;
  H  : HKEY;
  DType, DSize : Integer;
  Buff : PByteArray;
begin
  Screen.Cursor := crHourGlass;
  try
  lvFileTypes.Items.Clear;
  lvFileTypes.SortType := stNone;
  size := MAX_PATH;
  i := 0;
  SetString(Tmp,nil,size);
  lvFileTypes.Items.BeginUpdate;
  try
    while (RegEnumKeyEx(HKEY_CLASSES_ROOT,DWORD(i),PChar(Tmp),size,nil,nil,nil,nil)<>ERROR_NO_MORE_ITEMS) do
    begin
      if (Length(Tmp)>0) and (Tmp[1]<>'.') and (TMP<>'CLSID') then
      begin
        SetString(S,PChar(Tmp),size);
        if RegOpenKeyEx(HKEY_CLASSES_ROOT,PChar(S),0,KEY_READ or KEY_WRITE,H) = ERROR_SUCCESS then
        try
          LI := lvFileTypes.Items.Add;
          LI.Caption := S;
          if (RegQueryValueEx(H,nil,nil,@DType,nil,@DSize) = ERROR_SUCCESS) then
          begin
            GetMem(Buff,DSize);
            try
              if RegQueryValueEx(H,nil,nil,@DType,@Buff^,@DSize) = ERROR_SUCCESS then
              begin
                SetString(S,PChar(Buff),DSize);
                LI.SubItems.Add(S);
              end;
            finally
              FreeMem(Buff);
            end;
          end;
        finally
          RegCloseKey(H);
        end;
      end;
      Inc(i);
      size := MAX_PATH;
    end;
    lvFileTypes.SortType := stText;
  finally
    lvFileTypes.Items.EndUpdate;
  end;
  finally
    Screen.Cursor := crDefault;
  end;
end;

procedure TfrmTypeId.SetId(const Value: String);
var
  i,c : Integer;
  l,h : Integer;
  S : String;
begin
  FId := Value;
  h := lvFileTypes.Items.Count;
  l := 0;
  While h>=l do
  begin
    i := L+(H-L) div 2;
    S := lvFileTypes.Items[i].Caption;
    C := CompareText(Value,S);
    if C>0 then L := i+1
    else if C<0 then H := i-1
    else
    begin
      lvFileTypes.Selected := lvFileTypes.Items[i];
      lvFileTypes.Items[i].Focused := True;
      lvFileTypes.Items[i].MakeVisible(False);
      Break;
    end;
  end;
end;

procedure TfrmTypeId.Button1Click(Sender: TObject);
begin
  LoadList;
end;

procedure TfrmTypeId.btnOkClick(Sender: TObject);
begin
  if lvFileTypes.Selected<>nil then
    FId := lvFileTypes.Selected.Caption
  else
    FId := '';
  ModalResult := mrOk;
end;

procedure TfrmTypeId.lvFileTypesDblClick(Sender: TObject);
begin
  btnOkClick(nil);
end;

end.
