unit uCommand;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, RegExt;

type
  TfrmAction = class(TForm)
    edVerb: TEdit;
    edCName: TEdit;
    edCLine: TEdit;
    gbxDDE: TGroupBox;
    edDDEMes: TEdit;
    edDDEApp: TEdit;
    edDDEIf: TEdit;
    edDDETopic: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    btnOK: TButton;
    Button2: TButton;
    Button3: TButton;
    chbDDE: TCheckBox;
    OpenDialog1: TOpenDialog;
    procedure chbDDEClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure edVerbChange(Sender: TObject);
    procedure edCNameChange(Sender: TObject);
    procedure edCLineChange(Sender: TObject);
    procedure edDDEMesChange(Sender: TObject);
    procedure edDDEAppChange(Sender: TObject);
    procedure edDDEIfChange(Sender: TObject);
    procedure edDDETopicChange(Sender: TObject);
  private
    procedure ShowDDE;
    procedure EnableOk;
  public
    Verb : String;
    CommandName : String;
    CommandLine : String;
    UseDDE      : Boolean;
    DDE         : TRegDDEExec;
  end;

var
  frmAction: TfrmAction;  

implementation

{$R *.DFM}

procedure TfrmAction.chbDDEClick(Sender: TObject);
begin
  UseDDE := chbDDE.Checked;
  ShowDDE;
end;

procedure TfrmAction.ShowDDE;
begin
  gbxDDE.Visible := UseDDE;
  if UseDDE then Height := 404
            else Height := 200;
end;

procedure TfrmAction.EnableOk;
begin
  btnOK.Enabled := (Verb<>'') and (CommandLine<>'')
end;

procedure TfrmAction.FormCreate(Sender: TObject);
begin
  UseDDE := False;
  Verb := '';
  CommandName := '';
  CommandLine := '';
  FillChar(DDE,SizeOf(DDE),0);
end;

procedure TfrmAction.FormShow(Sender: TObject);
begin
  edVerb.Text     := Verb;
  edCName.Text    := CommandName;
  edcLine.Text    := CommandLine;
  edDDEMes.Text   := DDE.Message;
  edDDEApp.Text   := DDE.Application;
  edDDEIf.Text    := DDE.IfExec;
  edDDETopic.Text := DDE.Topic;
  chbDDE.Checked  := UseDDE;
  ShowDDE;
end;

procedure TfrmAction.Button3Click(Sender: TObject);
begin
  if OpenDialog1.Execute then
  begin
    edCLine.Text := OpenDialog1.FileName;
  end;
end;

procedure TfrmAction.edVerbChange(Sender: TObject);
begin
  Verb := Trim(edVerb.Text);
  EnableOk;
end;

procedure TfrmAction.edCNameChange(Sender: TObject);
begin
  CommandName := Trim(edCName.Text);
end;

procedure TfrmAction.edCLineChange(Sender: TObject);
begin
  CommandLine := Trim(edCLine.Text);
  EnableOk;
end;

procedure TfrmAction.edDDEMesChange(Sender: TObject);
begin
  DDE.Message := Trim(edDDEMes.Text);
end;

procedure TfrmAction.edDDEAppChange(Sender: TObject);
begin
  DDE.Application := Trim(edDDEApp.Text);
end;

procedure TfrmAction.edDDEIfChange(Sender: TObject);
begin
  DDE.IfExec := Trim(edDDEIf.Text);
end;

procedure TfrmAction.edDDETopicChange(Sender: TObject);
begin
  DDE.Topic := Trim(edDDETopic.Text);
end;

end.
 